=== debian/changelog ===
cli11 (2.1.2+ds-1) unstable; urgency=medium

  * New upstream version 2.1.2+ds
  * Refresh patch
  * Remove patch, fixed problem upstream
  * Use 4.6.0 standard
  * Move to unstable

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sun, 07 Nov 2021 18:16:52 +0000

cli11 (2.0.0+ds-1) experimental; urgency=medium

  * Initial release. (Closes: #927404)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 09 Aug 2021 17:50:55 +0000
