=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- \
	    -D CLI11_BUILD_EXAMPLES=OFF

override_dh_auto_build:
	dh_auto_build
	# patch auto-generated doxyfile to make build reproducible
	sed -i -e 's:STRIP_FROM_PATH[[:space:]]*=:STRIP_FROM_PATH = ..:g' obj-$(DEB_BUILD_GNU_TYPE)/docs/Doxyfile.docs
	dh_auto_build -- docs

override_dh_auto_install:
	dh_auto_install
	mv obj-$(DEB_BUILD_GNU_TYPE)/docs/html debian/tmp/html

%:
	dh $@
