=== debian/changelog ===
cli11 (2.3.2+ds-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.

  [ Jose Luis Rivero ]
  * New upstream version 2.3.2+ds
  * Fix compilation with catch2 version 2.3.x
    (Closes: #1054693)
  * Remove custom configure step in d/rules
  * Disable OptionalTest
  * Update d/copyright

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 13 Nov 2023 17:07:51 +0000
